/**************************************************************************//**
 * @file     servo.c
 * @version  V1.00
 * $Revision:
 * $Date: 14/08/15 6:09p $
 * @brief    servo setting source file
 *
 * @note
 * Copyright (C) 2014 Nuvoton Technology Corp. All rights reserved.
*****************************************************************************/
#include "M0518.h"

/*-----------------------------------------------------------------*/
/* Global Variables                                                */
/*-----------------------------------------------------------------*/
/* deviation0 controls the servos of body, thigh and shank on right-front, right-middle, right-back and left-back legs */
uint16_t deviation0[12] = {1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500};
/* deviation1 controls the servos of body, thigh and shank on left-middle, left-front legs and hanger */
uint16_t deviation1[8]  = {1500, 1500, 1500, 1500, 1500, 1500, 1500, 1500};


struct servo {
		BPWM_T *pwm;
		uint16_t channel;
};

struct servo1 {
		PWM_T *pwm;
		uint16_t channel;
};

struct servo 	SERVO[12];
struct servo1 	SERVO1[8];

void servomove(uint32_t ServoNum, uint16_t angle)
{

BPWM_SET_CMR(SERVO[ServoNum].pwm, SERVO[ServoNum].channel, angle);

}

void servomove1(uint32_t ServoNum, uint16_t angle)
{

PWM_SET_CMR(SERVO1[ServoNum].pwm, SERVO1[ServoNum].channel, angle);

}

void SERVO_Init(void)
{

		SERVO[0].pwm = BPWM0;
		SERVO[0].channel = 0;
		SERVO[1].pwm = BPWM0;
		SERVO[1].channel = 1;
		SERVO[2].pwm = BPWM0;
		SERVO[2].channel = 2;
		SERVO[3].pwm = BPWM0;
		SERVO[3].channel = 3;
		SERVO[4].pwm = BPWM0;
		SERVO[4].channel = 4;
		SERVO[5].pwm = BPWM0;
		SERVO[5].channel = 5;		
	  
		SERVO[6].pwm = BPWM1;
		SERVO[6].channel = 0;
		SERVO[7].pwm = BPWM1;
		SERVO[7].channel = 1;
		SERVO[8].pwm = BPWM1;
		SERVO[8].channel = 2;
		SERVO[9].pwm = BPWM1;
		SERVO[9].channel = 3;
		SERVO[10].pwm = BPWM1;
		SERVO[10].channel = 4;
		SERVO[11].pwm = BPWM1;
		SERVO[11].channel = 5;	
		
		SERVO1[0].pwm = PWM0;
		SERVO1[0].channel = 0;
		SERVO1[1].pwm = PWM0;
		SERVO1[1].channel = 1;
		SERVO1[2].pwm = PWM0;
		SERVO1[2].channel = 2;
		SERVO1[3].pwm = PWM0;
		SERVO1[3].channel = 3;
		SERVO1[4].pwm = PWM0;
		SERVO1[4].channel = 4;
		SERVO1[5].pwm = PWM0;
		SERVO1[5].channel = 5;		
	  
		SERVO1[6].pwm = PWM1;
		SERVO1[6].channel = 0;
		SERVO1[7].pwm = PWM1;
		SERVO1[7].channel = 1;

}

/*** (C) COPYRIGHT 2014 Nuvoton Technology Corp. ***/
