/**************************************************************************//**
 * @file     Buzzer.c
 * @version  V1.00
 * $Revision:
 * $Date: 14/08/15 6:09p $
 * @brief    Buzzer function source file
 *
 * @note
 * Copyright (C) 2014 Nuvoton Technology Corp. All rights reserved.
*****************************************************************************/
#include "M0518.h"

void Buzzer_Init(void)
{

		/* Set GPA.11 multi-function pins for PWM1 Channel 3 */
		SYS->GPA_MFP &= ~SYS_GPA_MFP_PA11_Msk;
		SYS->GPA_MFP |= SYS_GPA_MFP_PA11_PWM1_CH3;
		SYS->ALT_MFP3	&= ~SYS_ALT_MFP3_PA11_Msk;
		SYS->ALT_MFP3	|= SYS_ALT_MFP3_PA11_PWM1_CH3;
	
}

void Buzzer_Config(unsigned Enable)
{

		/* set PWM1 channel 3 output configuration */
		PWM_SET_PRESCALER(PWM1, 3, 49);
		PWM_SET_CNR(PWM1, 3, 0xFFFE);
		PWM_SET_CMR(PWM1, 3, 0x7FFF);
	
		/* Start PWM1 channel 2_3 counters */
    PWM_Start(PWM1, 0x4);
	
		if(Enable==1)
		/* Enable PWM1 Output path for PWM1 channel 3 */
			PWM_EnableOutput(PWM1, 0x8);
		else
			PWM_DisableOutput(PWM1, 0x8);
}

void Buzzer_Pulse(unsigned int Delay)
{

		Buzzer_Config(1);
		TIMER_Delay(TIMER0, Delay);
		Buzzer_Config(0);

}

/*** (C) COPYRIGHT 2014 Nuvoton Technology Corp. ***/
