/**************************************************************************//**
 * @file     HeadLED.c
 * @version  V1.00
 * $Revision:
 * $Date: 14/08/15 6:09p $
 * @brief    Control LED Headlight brightness function source file
 *
 * @note
 * Copyright (C) 2014 Nuvoton Technology Corp. All rights reserved.
*****************************************************************************/
#include "M0518.h"

void HeadLED_Init(void)
{
		
		/* Set GPF.5 multi-function pins for PWM1 Channel 5 to drive Head LED*/
		SYS->GPF_MFP &= ~(SYS_GPF_MFP_PF5_Msk);
		SYS->GPF_MFP |= (SYS_GPF_MFP_PF5_PWM1_CH5);
		SYS->ALT_MFP3	&= ~(SYS_ALT_MFP3_PF5_Msk);
		SYS->ALT_MFP3	|= (SYS_ALT_MFP3_PF5_PWM1_CH5);
		/* Start PWM1 channel 4_5 counters */
    PWM_Start(PWM1, 0x10);
		
}

void HeadLED_Control(unsigned int Duty)
{

		if(Duty == 0)
				/* Disable PWM1 Output path for PWM1 channel 5 */
				PWM_DisableOutput(PWM1, 0x20);
		else
		{
				/* Enable PWM1 Output path for PWM1 channel 5 */
				PWM_EnableOutput(PWM1, 0x20);
				/* set BPWM1 channel 5 output configuration */
				PWM_SET_PRESCALER(PWM1, 4, 1);
				PWM_SET_CNR(PWM1, 4, 50000000/2/38000);
				/* LED Headlight goes out when Duty is 100% */
				PWM_SET_CMR(PWM1, 4, 50000000*(100 - Duty)/2/38000/100);
		}
	
}

/*** (C) COPYRIGHT 2014 Nuvoton Technology Corp. ***/
